Bug 1956746 - Review Request: rust-vm-memory - Safe abstractions for accessing the VM physical memory
Summary: Review Request: rust-vm-memory - Safe abstractions for accessing the VM physi...
Keywords:
Status: ASSIGNED
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
medium
medium
Target Milestone: ---
Assignee: Fabiano Fidêncio
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1892236
Blocks:
TreeView+ depends on / blocked
 
Reported: 2021-05-04 10:46 UTC by Sergio Lopez
Modified: 2021-05-14 14:12 UTC (History)
3 users (show)

Fixed In Version:
Doc Type: If docs needed, set a value
Doc Text:
Clone Of:
Environment:
Last Closed:
Type: ---
fidencio: fedora-review+


Attachments (Terms of Use)

Comment 1 Fabiano Fidêncio 2021-05-06 11:08:56 UTC
Sergio,

When using fedora-review tool I'm hitting some installation errors:
```
Installation errors
-------------------
INFO: mock.py version 2.9 starting (python version = 3.9.4, NVR = mock-2.9-2.fc34)...
Start: init plugins
INFO: selinux enabled
Finish: init plugins
INFO: Signal handler active
Start: run
Start: chroot init
INFO: calling preinit hooks
INFO: enabled root cache
INFO: enabled package manager cache
Start: cleaning package manager metadata
Finish: cleaning package manager metadata
INFO: enabled HW Info plugin
Mock Version: 2.9
INFO: Mock Version: 2.9
Finish: chroot init
INFO: installing package(s): /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+backend-mmap-devel-0.5.0-1.fc35.noarch.rpm /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+default-devel-0.5.0-1.fc35.noarch.rpm /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory-devel-0.5.0-1.fc35.noarch.rpm /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+arc-swap-devel-0.5.0-1.fc35.noarch.rpm /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+backend-atomic-devel-0.5.0-1.fc35.noarch.rpm
ERROR: Command failed:
 # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/ --releasever 35 --setopt=deltarpm=False --allowerasing --disableplugin=local --disableplugin=spacewalk install /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+backend-mmap-devel-0.5.0-1.fc35.noarch.rpm /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+default-devel-0.5.0-1.fc35.noarch.rpm /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory-devel-0.5.0-1.fc35.noarch.rpm /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+arc-swap-devel-0.5.0-1.fc35.noarch.rpm /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+backend-atomic-devel-0.5.0-1.fc35.noarch.rpm --setopt=tsflags=nocontexts

```

Have you faced those before?
Also, shouldn't this package `Requires: vmm-sys-util`?

Comment 2 Sergio Lopez 2021-05-06 13:13:27 UTC
(In reply to Fabiano Fidêncio from comment #1)
> Sergio,
> 
> When using fedora-review tool I'm hitting some installation errors:
> ```
> Installation errors
> -------------------
> INFO: mock.py version 2.9 starting (python version = 3.9.4, NVR =
> mock-2.9-2.fc34)...
> Start: init plugins
> INFO: selinux enabled
> Finish: init plugins
> INFO: Signal handler active
> Start: run
> Start: chroot init
> INFO: calling preinit hooks
> INFO: enabled root cache
> INFO: enabled package manager cache
> Start: cleaning package manager metadata
> Finish: cleaning package manager metadata
> INFO: enabled HW Info plugin
> Mock Version: 2.9
> INFO: Mock Version: 2.9
> Finish: chroot init
> INFO: installing package(s):
> /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+backend-mmap-
> devel-0.5.0-1.fc35.noarch.rpm
> /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+default-devel-0.
> 5.0-1.fc35.noarch.rpm
> /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory-devel-0.5.0-1.
> fc35.noarch.rpm
> /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+arc-swap-devel-
> 0.5.0-1.fc35.noarch.rpm
> /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+backend-atomic-
> devel-0.5.0-1.fc35.noarch.rpm
> ERROR: Command failed:
>  # /usr/bin/dnf --installroot /var/lib/mock/fedora-rawhide-x86_64/root/
> --releasever 35 --setopt=deltarpm=False --allowerasing --disableplugin=local
> --disableplugin=spacewalk install
> /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+backend-mmap-
> devel-0.5.0-1.fc35.noarch.rpm
> /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+default-devel-0.
> 5.0-1.fc35.noarch.rpm
> /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory-devel-0.5.0-1.
> fc35.noarch.rpm
> /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+arc-swap-devel-
> 0.5.0-1.fc35.noarch.rpm
> /home/fidencio/1956746-rust-vm-memory/results/rust-vm-memory+backend-atomic-
> devel-0.5.0-1.fc35.noarch.rpm --setopt=tsflags=nocontexts
> 
> ```
> 
> Have you faced those before?

Thanks for the review, Fabiano.

You're right, I've tried this on a clean machine and fails too:

Error: 
 Problem 1: conflicting requests
  - nothing provides crate(arc-swap/default) >= 1.0.0 needed by rust-vm-memory+arc-swap-devel-0.5.0-1.fc35.noarch
 Problem 2: conflicting requests
  - nothing provides crate(arc-swap/default) >= 1.0.0 needed by rust-vm-memory+backend-atomic-devel-0.5.0-1.fc35.noarch
(try to add '--skip-broken' to skip uninstallable packages or '--nobest' to use not only best candidate packages)

So the rust-arc-swap package in Fedora is still at version 0.4.7, while vm-memory requires >= 1.0.0. The latest version is 1.2.0. Should I send a PR to https://src.fedoraproject.org/rpms/rust-arc-swap ?

> Also, shouldn't this package `Requires: vmm-sys-util`?

The `rust-packaging` magic extracts the dependencies from `Cargo.toml`. You can also put them explicitly in the specfile, but every crate I've seen relies on `rust-packaging`.

Comment 3 Fabiano Fidêncio 2021-05-06 20:50:14 UTC
> You're right, I've tried this on a clean machine and fails too:
> 
> Error: 
>  Problem 1: conflicting requests
>   - nothing provides crate(arc-swap/default) >= 1.0.0 needed by
> rust-vm-memory+arc-swap-devel-0.5.0-1.fc35.noarch
>  Problem 2: conflicting requests
>   - nothing provides crate(arc-swap/default) >= 1.0.0 needed by
> rust-vm-memory+backend-atomic-devel-0.5.0-1.fc35.noarch
> (try to add '--skip-broken' to skip uninstallable packages or '--nobest' to
> use not only best candidate packages)
> 
> So the rust-arc-swap package in Fedora is still at version 0.4.7, while
> vm-memory requires >= 1.0.0. The latest version is 1.2.0. Should I send a PR
> to https://src.fedoraproject.org/rpms/rust-arc-swap ?

I saw you already opened the PR, thanks for taking care of this.  I also sent a ping to the maintainer, hopefully it'll get merged soon.

For reference:
https://src.fedoraproject.org/rpms/rust-arc-swap/pull-request/1

Comment 4 Fabiano Fidêncio 2021-05-10 11:45:33 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
     Note: Checking patched sources after %prep for licenses. Licenses
     found: "Unknown or generated", "*No copyright* Apache License 2.0",
     "BSD 3-clause "New" or "Revised" License". 29 files have unknown
     license. Detailed output of licensecheck in
     /home/fidencio/1956746-rust-vm-memory/licensecheck.txt
     Note: that's expected, the source files follow the license stated by
     the package itself (ASL or BSD-3-Clause)
[x]: License file installed when any subpackage combination is installed.
[x]: If the package is under multiple licenses, the licensing breakdown
     must be documented in the spec.
[x]: %build honors applicable compiler flags or justifies otherwise.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[x]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[-]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 10240 bytes in 1 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package must not depend on deprecated() packages.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Fully versioned dependency in subpackages if applicable.
     Note: No Requires: %{name}%{?_isa} = %{version}-%{release} in rust-vm-
     memory-devel , rust-vm-memory+default-devel , rust-vm-memory+arc-swap-
     devel , rust-vm-memory+backend-atomic-devel , rust-vm-memory+backend-
     mmap-devel
[?]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[x]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[-]: Sources are verified with gpgverify first in %prep if upstream
     publishes signatures.
     Note: gpgverify is not used.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: SourceX is a working URL.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: rust-vm-memory-devel-0.5.0-1.fc35.noarch.rpm
          rust-vm-memory+default-devel-0.5.0-1.fc35.noarch.rpm
          rust-vm-memory+arc-swap-devel-0.5.0-1.fc35.noarch.rpm
          rust-vm-memory+backend-atomic-devel-0.5.0-1.fc35.noarch.rpm
          rust-vm-memory+backend-mmap-devel-0.5.0-1.fc35.noarch.rpm
          rust-vm-memory-0.5.0-1.fc35.src.rpm
rust-vm-memory-devel.noarch: W: invalid-url URL: https://crates.io/crates/vm-memory HTTP Error 404: Not Found
rust-vm-memory-devel.noarch: W: hidden-file-or-dir /usr/share/cargo/registry/vm-memory-0.5.0/.cargo-checksum.json
rust-vm-memory+default-devel.noarch: W: invalid-url URL: https://crates.io/crates/vm-memory HTTP Error 404: Not Found
rust-vm-memory+default-devel.noarch: W: no-documentation
rust-vm-memory+arc-swap-devel.noarch: W: invalid-url URL: https://crates.io/crates/vm-memory HTTP Error 404: Not Found
rust-vm-memory+arc-swap-devel.noarch: W: no-documentation
rust-vm-memory+backend-atomic-devel.noarch: W: invalid-url URL: https://crates.io/crates/vm-memory HTTP Error 404: Not Found
rust-vm-memory+backend-atomic-devel.noarch: W: no-documentation
rust-vm-memory+backend-mmap-devel.noarch: W: invalid-url URL: https://crates.io/crates/vm-memory HTTP Error 404: Not Found
rust-vm-memory+backend-mmap-devel.noarch: W: no-documentation
rust-vm-memory.src: W: invalid-url URL: https://crates.io/crates/vm-memory HTTP Error 404: Not Found
6 packages and 0 specfiles checked; 0 errors, 11 warnings.




Rpmlint (installed packages)
----------------------------
rust-vm-memory+default-devel.noarch: W: invalid-url URL: https://crates.io/crates/vm-memory HTTP Error 404: Not Found
rust-vm-memory+default-devel.noarch: W: no-documentation
rust-vm-memory+backend-atomic-devel.noarch: W: invalid-url URL: https://crates.io/crates/vm-memory HTTP Error 404: Not Found
rust-vm-memory+backend-atomic-devel.noarch: W: no-documentation
rust-vm-memory+backend-mmap-devel.noarch: W: invalid-url URL: https://crates.io/crates/vm-memory HTTP Error 404: Not Found
rust-vm-memory+backend-mmap-devel.noarch: W: no-documentation
rust-vm-memory-devel.noarch: W: invalid-url URL: https://crates.io/crates/vm-memory HTTP Error 404: Not Found
rust-vm-memory-devel.noarch: W: hidden-file-or-dir /usr/share/cargo/registry/vm-memory-0.5.0/.cargo-checksum.json
rust-vm-memory+arc-swap-devel.noarch: W: invalid-url URL: https://crates.io/crates/vm-memory HTTP Error 404: Not Found
rust-vm-memory+arc-swap-devel.noarch: W: no-documentation
5 packages and 0 specfiles checked; 0 errors, 10 warnings.



Source checksums
----------------
https://crates.io/api/v1/crates/vm-memory/0.5.0/download#/vm-memory-0.5.0.crate :
  CHECKSUM(SHA256) this package     : 625f401b1b8b3ac3d43f53903cd138cfe840bd985f8581e553027b31d2bb8ae8
  CHECKSUM(SHA256) upstream package : 625f401b1b8b3ac3d43f53903cd138cfe840bd985f8581e553027b31d2bb8ae8


Requires
--------
rust-vm-memory-devel (rpmlib, GLIBC filtered):
    cargo
    crate(libc/default)

rust-vm-memory+default-devel (rpmlib, GLIBC filtered):
    cargo
    crate(vm-memory)

rust-vm-memory+arc-swap-devel (rpmlib, GLIBC filtered):
    cargo
    crate(arc-swap/default)
    crate(vm-memory)

rust-vm-memory+backend-atomic-devel (rpmlib, GLIBC filtered):
    cargo
    crate(arc-swap/default)
    crate(vm-memory)

rust-vm-memory+backend-mmap-devel (rpmlib, GLIBC filtered):
    cargo
    crate(vm-memory)



Provides
--------
rust-vm-memory-devel:
    crate(vm-memory)
    rust-vm-memory-devel

rust-vm-memory+default-devel:
    crate(vm-memory/default)
    rust-vm-memory+default-devel

rust-vm-memory+arc-swap-devel:
    crate(vm-memory/arc-swap)
    rust-vm-memory+arc-swap-devel

rust-vm-memory+backend-atomic-devel:
    crate(vm-memory/backend-atomic)
    rust-vm-memory+backend-atomic-devel

rust-vm-memory+backend-mmap-devel:
    crate(vm-memory/backend-mmap)
    rust-vm-memory+backend-mmap-devel



Generated by fedora-review 0.7.6 (b083f91) last change: 2020-11-10
Command line :/usr/bin/fedora-review -b 1956746
Buildroot used: fedora-rawhide-x86_64
Active plugins: Shell-api, Generic
Disabled plugins: SugarActivity, Java, R, Haskell, PHP, Ocaml, fonts, Python, C/C++, Perl
Disabled flags: EPEL6, EPEL7, DISTTAG, BATCH, EXARCH

Comment 5 Fabiano Fidêncio 2021-05-10 11:47:34 UTC
Sergio, everything looks good to me, and the issue blocking this one is now solved (and the packages are present in the compose).
Thanks for working on this, and for acting on the blocker parts.

Please, go ahead and submit this one to be added to Fedora.

Comment 6 Gwyn Ciesla 2021-05-14 14:12:38 UTC
(fedscm-admin):  The Pagure repository was created at https://src.fedoraproject.org/rpms/rust-vm-memory


Note You need to log in before you can comment on or make changes to this bug.